﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;
using Syncfusion.DocToPDFConverter;
using Syncfusion.Pdf;
using System.Collections;

namespace Sample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            WordDocument document = new WordDocument(@"..\\..\\Data\\Bookmark_Table.docx", FormatType.Docx);
            BookmarksNavigator bookmarkNavigator = new BookmarksNavigator(document);
            bookmarkNavigator.MoveToBookmark("Bookmark");
            var textBodyPart = bookmarkNavigator.GetBookmarkContent();
            IterateTextBody(textBodyPart.BodyItems);

            bookmarkNavigator.ReplaceBookmarkContent(textBodyPart);
            document.Save(@"..\\..\\Output\\Sample.docx", FormatType.Docx);
            document.Close();
        }
        private static void IterateTextBody(EntityCollection bodyItems)
        {

            //Iterates through each of the child items of WTextBody

            for (int i = 0; i < bodyItems.Count; i++)
            {

                //IEntity is the basic unit in DocIO DOM. 

                //Accesses the body items (should be either paragraph or table) as IEntity

                IEntity bodyItemEntity = bodyItems[i];

                //A Text body has 2 types of elements - Paragraph and Table

                //Decides the element type by using EntityType

                switch (bodyItemEntity.EntityType)
                {

                    case EntityType.Paragraph:

                        WParagraph paragraph = bodyItemEntity as WParagraph;

                        //Modify the character format of the text in the paragraph

                        paragraph.ParagraphFormat.AfterSpacing = 12f;
                        for (int j = 0; j < paragraph.ChildEntities.Count; j++)
                        {
                            if (paragraph.ChildEntities[j] is WTextRange)
                            {
                                WTextRange text = paragraph.ChildEntities[j] as WTextRange;
                                text.CharacterFormat.FontSize = 12;
                                text.CharacterFormat.TextColor = Color.Green;
                            }
                        }

                        break;

                    case EntityType.Table:

                        //Table is a collection of rows and cells

                        //Iterates through table's DOM

                        IterateTable(bodyItemEntity as WTable);

                        break;

                }

            }

        }

        private static void IterateTable(WTable table)
        {

            //Iterates the row collection in a table

            foreach (WTableRow row in table.Rows)
            {

                //Iterates the cell collection in a table row

                foreach (WTableCell cell in row.Cells)
                {

                    //Table cell is derived from (also a) TextBody

                    //Reusing the code meant for iterating TextBody

                    IterateTextBody(cell.ChildEntities);

                }

            }

        }
    }
}
